<?php
require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$delimiter=stripslashes($_POST['delimiter']);

function parse_sequences ($inputseqs) {
  $sequences = parse_fasta($inputseqs, 0, "-"); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error = "Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
    return array(1,$error);
  }
  return array(0,$sequences);
}

function get_exploded_table($seqs, $explode=FALSE, $transpose=FALSE, $delimiter="", $endline="\n", $startline="") {
  // Normal table, col.1 = header, col.2. =seq pos 0 etc....
  $out=array(array()); // data grid
  for ($j=0; $j<count($seqs); $j++) { // j = coloumns
    $out[0][$j]=$seqs[$j][0]; // add sequence header to coloumn j
    $s=$seqs[$j][1];
    if ($explode) {
      for ($i=0; $i<strlen($s); $i++) { // i = rows
	$out[$i+1][$j] = $seqs[$j][1][$i];     
      }
    } else {
      $out[1][$j] = $seqs[$j][1];     
    }
  }
  if ($transpose) {
    // flip array
    $temp="";
    for ($j=0; $j<count($out); $j++) { 
      for ($i=0; $i<count($out[$j]); $i++) { 
	$temp[$i][$j]=$out[$j][$i];
      }
    }
    $out=$temp;
  }
  $t=array();
  for ($j=0; $j<count($out); $j++) { 
    $t[$j] = $startline.implode($out[$j], $delimiter);
  }
  $out=implode($t, $endline);
  return $out;
}


if ($submit) {
  $r= parse_sequences($inputseqs);
  if ($r[0]=="0") {
    $sequences=$r[1];
    $r=array();
    $r['text']= get_exploded_table($sequences, $_POST['explode'], $_POST['transpose'], $delimiter, "\n", "");
    $r['html']= "<br><table border=1>".get_exploded_table($sequences, $_POST['explode'], $_POST['transpose'], "</td><td>", "</td></tr>", "<tr><td>")."</table><br>";
    $r['textlabel']="Sequences in csv format";
    $r['htmllabel']="Sequences in table format";
    $r['filename']="sequence_table.dat";
    $r['filelabel']="Save sequences";
  } else {
    $error = $r[1];
    $r='';
  }
}
//
// BEGIN HTML OUTPUT!
//
show_page_header("Fasta2excel converter", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>

<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta_splitter.fa") 
?>
<P>
<!-- Settings fieldset -->

<fieldset>
<legend>Settings</legend>
<label>Flip rows and coloumns</label>
<input type="checkbox" name ="transpose" <?php if ($_POST['transpose']) { echo 'CHECKED'; } ?> ></p>
<P>

<P>
<label>Split sequences base by base</label>
<input type="checkbox" name ="explode" <?php if ($_POST['explode'] or $submit_example ) { echo 'CHECKED'; } ?> ></p>
<P>
<label>Use this character as delimiter when saving to disk: </label>
<input type="text" name ="delimiter" size=10 value="<?php if($submit) {echo $delimiter;} if ($submit_example) { echo ';';} ?>" ></p>
<?php
show_submit_buttons ($mm="Convert data")
?>
</fieldset>

</form>

<!-- RESULTS SECTION  -->

<?php
   if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
   }
 
if ($submit and !$error) {
  $b[] = get_save_button($r, 'r1');
  print get_save_form($b, "Save datasets");
  print get_results_from_buttons($b);
  
}

//
// END HTML OUTPUT
//
?>
<?php
show_page_footer();
?>
