<?php

require('./tools/seqtools.php');// include sequence functions, parsing etc.
require('./tools/formtools.php');
require('./tools/reporttools.php');

// Form buttons from main form
$submit = $_POST['submit'];
$submit_example = $_POST['submit_example'];
$adv_delimiter=$_POST['adv_delimiter'];

//
// Analysis
//

function parse_sequences($sequences) {
  global $adv_delimiter;
  $k = 0;// initalise haplotype number
  for ($i=0; $i<count($sequences); $i++) {// all sequences
    $hit =0;
    for ($j=0; $j<=$k; $j++){ // search all known haplotypes for current sequence
      if ($sequences[$i][1] == $haplotypes[$j][1]){
	$haplotypes[$j][0][] = $sequences[$i][0];//add header of sequence $i to list of sequences with haplotype
	$haplotype=$j; // Put haplotype number to sequence
	$hit = 1;// found existing haplotype
	break ;
      }
    }
    // All haplotypes searched
    // Check to see if anything was found
    // if not, create new haplotype
    if ($hit == 0) {//nothing found
      $haplotypes[$k][0][] = $sequences[$i][0];// add header of sequence $i to list of sequences with haplotype
      $haplotypes[$k][1] = $sequences[$i][1];// haplotype DNA sequence
      $haplotypes[$k][2] = $k+1; 
      
      $haplotypes[$k][3]=$k+1; // number
      $haplotype=$k; // Put haplotype number to sequence
      $hit =0;
      $k++;// add 1 to $k
    }
    // Done for all sequences
    $h = explode($adv_delimiter, $sequences[$i][0]);
    $id=$h[0];
    $sex=$h[1];
    $pop=$h[2];

    $sequences[$i]['id']=$id;
    $sequences[$i]['pop']=$pop;
    $sequences[$i]['sex']=$sex; 
    $sequences[$i]['haplotype']=$haplotype;
  }
  $r['haplotypes']=$haplotypes;
  $r['sequences']=$sequences;
  return ($r);
}


function get_popdata ($sequences, $sexfilter="") {
  for ($i=0; $i<count($sequences); $i++) {// all sequences
    $seq=$sequences[$i];
    $id = $seq['id'];
    $pop= $seq['pop'];
    $sex= $seq['sex'];
    $haplotype=$seq['haplotype'];
    if ($sex==$sexfilter or $sexfilter=="") {
      $popdata[$pop]['haplotypes'][$haplotype]+=1;
      $popdata[$pop]['sequences'][]= $i; // putting sequence number in pop group
    }
  }
  ksort($popdata);
  return $popdata;
}


function get_migrate($sequences, $fn='infile') {
  global $adv_delimiter;
  $r=parse_sequences($sequences);
  $sequences=$r['sequences'];
  $haplotypes=$r['haplotypes'];
  $popdata=get_popdata($sequences);
  $pops=count($popdata); // number of populations
  $numberofhaplotypes = count($haplotypes);
  $len=strlen($haplotypes[0][1]); // getting length of first sequence

    ///////////////////////////////////////////////
    ///
    /// Migrate output
    ///
    ///////////////////////////////////////////////
    $migrate = "   $pops 1 Migrate input file from FaBox\n"; // <POPS> <LOCI> [TITLE] 
    $migrate.= $len."\n"; // <LOCUS LENGTH> (only 1 locus)
    foreach($popdata AS $pop => $r ){
      $s=$r['sequences'];
      $migrate.= count($r['sequences'])."   $pop\n"; # <INDIVIDUALS IN LOCUS1> TItle for pop
	foreach ($r['sequences'] AS $s) {
	  $h = explode($adv_delimiter, $sequences[$s][0]);
	  $id=$h[0];
	  $seq= $sequences[$s][1];
	  $migrate.= substr(($id."            "), 0, 10).$seq."\n";
	}
    }
    ////////// END MIGRATE ////////////////////////

    $r['text'] = $migrate;
    $r['textlabel']="Migrate input file";
    
    $r['html'] = "<PRE>$migrate</PRE>\n";
    $r['htmllabel']="Migrate input file";
    
    $r['filename']= "$fn";
    $r['filelabel']="Save Migrate input file";
    return $r;
}


if ($submit) {
  $sequences = parse_fasta($inputseqs, 1); // returns array of sequences, each consist of two elements: header and sequence, i.e. $var[0][0] = header of seq 1, $var[0][1] = sequence 1 etc...
  if (count($sequences) ==0){
    $error="Couldn't parse FASTA input correctly, please submit fasta formatted sequences";
  } 
}

//
// BEGIN HTML OUTPUT!
//
show_page_header("fasta2migrate", "<a href='#formtools.results'>Analysis finished, results are at bottom (or click here)</a>", $submit, $error);
?>
<!-- INPUT FORM -->
<form action="#" method='POST' enctype='multipart/form-data'>
<?php
show_fieldset_inputseqs ($submit_example, $inputseqs, "./examples/fasta2migrate.fa") 
?>
<!-- Settings fieldset -->
<fieldset>
<legend>Settings</legend>
<P><label for="adv_limiter">Header field delimiter</label><input type="text" name ="adv_delimiter" size=10 value="<?php if($adv_delimiter) {echo $adv_delimiter;} else {echo "|";} ?>"/></P>
<?php
show_submit_buttons("Extract headers");
?>
<div id='small'>
You probably want to format your input file containing data from different populations (otherwise it doesn't make sense to use migrate).
 You should format your headers like this:
<pre>>ID [delimiter] Sex [delimiter] Population</pre>
</div>
</fieldset>
</form>

<!-- RESULTS SECTION FOLLOW -->
<?php
if ($error) {
     print "<h1><font color ='#AA0000'><br> $error</font></h1>\n";
}
if ($submit and !$error) {
  // Reports
  $migrate_report=get_migrate($sequences, 'infile');
  print "<a name='formtools.results'>";
  //
  // Get buttons from all the resulting objects
  //
  $b[] = get_save_button($migrate_report, "r2");

  print get_save_form($b, "Save results to disk");
  print "</form>";
  
  print get_results_from_buttons($b);
}
   
 

//
// END HTML OUTPUT
//
?>

<?php
show_page_footer();
?>
