<?php
require('./tools/formtools.php');
show_page_header("Fasta header extractor and splitter - help page");
?>
<P>
The fasta header extractor and splitter are able to do two simple tasks:
<ol>
<li>Extract all the headers from a fasta file and output them in table format. This can be copied to excel for further editing. (The equivalent linux one-liner is:  grep '>' sequencefile.fasta >outputfile.tsv
																 <li>Split each header using a specified character. Typically, this is useful for sequences downloaded from genbank with headers like this:
<pre>
>gi|93102408|ref|NM_007988.3| Mus musculus fatty acid synthase (Fasn), mRNA
>gi|75677473|ref|NM_001033326.1| Mus musculus dehydrogenase/reductase (SDR family) X chromosome (Dhrsx), mRNA
>gi|41872630|ref|NM_004104.4| Homo sapiens fatty acid synthase (FASN), mRNA
>gi|32455238|ref|NM_181755.1| Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 2, mRNA
>gi|32455237|ref|NM_005525.2| Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 1, mRNA
</pre>
You may then use '|' as the splitting character, which will give you the following output:
<P>
<table class='tableborder'>
<tr><td>Original header</td><td>Splitted header fields</td></tr>
<tr><td>gi|93102408|ref|NM_007988.3| Mus musculus fatty acid synthase (Fasn), mRNA</td><td>gi</td><td>93102408</td><td>ref</td><td>NM_007988.3</td><td> Mus musculus fatty acid synthase (Fasn), mRNA</td></tr>
<tr><td>gi|75677473|ref|NM_001033326.1| Mus musculus dehydrogenase/reductase (SDR family) X chromosome (Dhrsx), mRNA</td><td>gi</td><td>75677473</td><td>ref</td><td>NM_001033326.1</td><td> Mus musculus dehydrogenase/reductase (SDR family) X chromosome (Dhrsx), mRNA</td></tr>

<tr><td>gi|41872630|ref|NM_004104.4| Homo sapiens fatty acid synthase (FASN), mRNA</td><td>gi</td><td>41872630</td><td>ref</td><td>NM_004104.4</td><td> Homo sapiens fatty acid synthase (FASN), mRNA</td></tr>
<tr><td>gi|32455238|ref|NM_181755.1| Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 2, mRNA</td><td>gi</td><td>32455238</td><td>ref</td><td>NM_181755.1</td><td> Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 2, mRNA</td></tr>
<tr><td>gi|32455237|ref|NM_005525.2| Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 1, mRNA</td><td>gi</td><td>32455237</td><td>ref</td><td>NM_005525.2</td><td> Homo sapiens hydroxysteroid (11-beta) dehydrogenase 1 (HSD11B1), transcript variant 1, mRNA</td></tr>
</table>
<P>This output can be opened in excel and later reinserted into your sequences using the header replacer tool.
</ol>

<?php
show_page_footer();
?>
