<?php
require('./tools/formtools.php');
show_page_header("Fasta header replacer - help page");
?>
<h3>It is highly recommended to try the example button on all services.</h3>
<P>
The fasta header replacer is able to perform several tasks:
<ol>
<li>Replace all headers one by one. So the first sequence get the first new header, the second sequence gets the second header and so on...<br>
This is the default behaviour and only requires two inputs: Sequences and new headers.<P>
<li>Replace all headers by non-exact matching between search terms and the old headers. This is more tricky but may be useful for some. If your headers look like this:
<pre>
>gi|109693353|gb|DQ535174.1| Homo sapiens isolate YM3-CON-14-VH3-13 immunglobulin heavy chain variable region gene, partial cds
>gi|109693333|gb|DQ535153.1| Homo sapiens isolate YM3-CON-4-VH3-59 immunglobulin heavy chain variable region gene, partial cds
>gi|109693331|gb|DQ535129.1| Homo sapiens isolate YM2-CON-14-VH3-29 immunglobulin heavy chain variable region gene, partial cds
>gi|109693329|gb|DQ535128.1| Homo sapiens isolate YM2-CON-14-VH3-78 immunglobulin heavy chain variable region gene, partial cds
</pre>
And I would like to change them to 
<pre>
Globulin_DQ535129
Globulin_DQ535128
Globulin_DQ535174
Globulin_DQ535153
</pre>

I can search the old headers using
<pre>
DQ535129
DQ535128
DQ535174
DQ535153
</pre>
as search terms. NOTE that the order of the sequences is ignored
(i.e. your sequences doesn't need to be in the same order as your
headers - as long as your search terms and new headers are in the same
order (typically from a spreadsheet).<P>

<li>Replace all headers by EXACT matching between your search terms
and the old headers. Same as above, but it requires that your search
term matches the entire old header. In the above example nothing would
be matched, but if you searched

<pre>
>gi|109693353|gb|DQ535174.1| Homo sapiens isolate YM3-CON-14-VH3-13 immunglobulin heavy chain variable region gene, partial cds
>gi|109693333|gb|DQ535153.1| Homo sapiens isolate YM3-CON-4-VH3-59 immunglobulin heavy chain variable region gene, partial cds
>gi|109693331|gb|DQ535129.1| Homo sapiens isolate YM2-CON-14-VH3-29 immunglobulin heavy chain variable region gene, partial cds
>gi|109693329|gb|DQ535128.1| Homo sapiens isolate YM2-CON-14-VH3-78 immunglobulin heavy chain variable region gene, partial cds
</pre>

with 
<pre>
gi|109693331|gb|DQ535129.1| Homo sapiens isolate YM2-CON-14-VH3-29 immunglobulin heavy chain variable region gene, partial cds
</pre>
as search term and 
<pre>
Homo sapiens isolate YM2-CON-14-VH3-29
</pre>
as replace term it will give you some warnings and the following
output:

<pre>
>gi|109693353|gb|DQ535174.1| Homo sapiens isolate YM3-CON-14-VH3-13 immunglobulin heavy chain variable region gene, partial cds
>gi|109693333|gb|DQ535153.1| Homo sapiens isolate YM3-CON-4-VH3-59 immunglobulin heavy chain variable region gene, partial cds
>Homo sapiens isolate YM2-CON-14-VH3-29
>gi|109693329|gb|DQ535128.1| Homo sapiens isolate YM2-CON-14-VH3-78 immunglobulin heavy chain variable region gene, partial cds
</pre>
<P>
Tadaa! It found and changed the header in sequence number 3.
</ol>

<?php
show_page_footer();
?>
